From 8f18318902f205002b13ea17b3bf53a712f3c879 Mon Sep 17 00:00:00 2001
From: David Tolnay <dtolnay@gmail.com>
Date: Sep 02 2020 04:24:40 +0000
Subject: [PATCH 819/2232] Guard our path joins from going outside out-dir


---

diff --git a/gen/build/src/lib.rs b/gen/build/src/lib.rs
index c611eea..fa7b825 100644
--- a/gen/build/src/lib.rs
+++ b/gen/build/src/lib.rs
@@ -62,7 +62,7 @@ mod syntax;
 use crate::error::{Error, Result};
 use crate::gen::error::report;
 use crate::gen::{fs, Opt};
-use crate::paths::TargetDir;
+use crate::paths::{PathExt, TargetDir};
 use cc::Build;
 use std::io::{self, Write};
 use std::iter;
@@ -162,14 +162,21 @@ fn symlink_crate(prj: &Project, build: &mut Build) {
 fn generate_bridge(prj: &Project, build: &mut Build, rust_source_file: &Path) -> Result<()> {
     let opt = Opt::default();
     let generated = gen::generate_from_path(rust_source_file, &opt);
+    let ref rel_path = paths::local_relative_path(rust_source_file);
+
+    let ref rel_path_h = rel_path.with_appended_extension(".h");
+    let ref header_path = paths::namespaced(&prj.out_dir, rel_path_h);
+    write(header_path, &generated.header)?;
+    paths::symlink_namespaced(header_path, &prj.out_dir, rel_path);
+    if let TargetDir::Path(target_dir) = &prj.target_dir {
+        paths::symlink_namespaced(header_path, target_dir, rel_path);
+        paths::symlink_namespaced(header_path, target_dir, rel_path_h);
+    }
 
-    let header_path = paths::out_with_extension(prj, rust_source_file, ".h");
-    write(&header_path, &generated.header)?;
-    paths::symlink_header(prj, &header_path, rust_source_file);
-
-    let implementation_path = paths::out_with_extension(prj, rust_source_file, ".cc");
-    write(&implementation_path, &generated.implementation)?;
-    build.file(&implementation_path);
+    let ref rel_path_cc = rel_path.with_appended_extension(".cc");
+    let ref implementation_path = paths::namespaced(&prj.out_dir, rel_path_cc);
+    write(implementation_path, &generated.implementation)?;
+    build.file(implementation_path);
     Ok(())
 }
 
diff --git a/gen/build/src/paths.rs b/gen/build/src/paths.rs
index d6ff359..1a423dc 100644
--- a/gen/build/src/paths.rs
+++ b/gen/build/src/paths.rs
@@ -2,8 +2,8 @@ use crate::error::{Error, Result};
 use crate::gen::fs;
 use crate::Project;
 use std::env;
-use std::ffi::OsString;
-use std::path::{Path, PathBuf};
+use std::ffi::{OsStr, OsString};
+use std::path::{Component, Path, PathBuf};
 
 pub(crate) enum TargetDir {
     Path(PathBuf),
@@ -16,42 +16,44 @@ pub(crate) fn out_dir() -> Result<PathBuf> {
         .ok_or(Error::MissingOutDir)
 }
 
-// Symlink the header file into a predictable place. The header generated from
-// path/to/mod.rs gets linked to target/cxxbridge/path/to/mod.rs.h.
-pub(crate) fn symlink_header(prj: &Project, path: &Path, original: &Path) {
-    if let TargetDir::Unknown = prj.target_dir {
-        return;
+// Given a path provided by the user, determines where generated files related
+// to that path should go in our out dir. In particular we don't want to
+// accidentally write generated code upward of our out dir, even if the user
+// passed a path containing lots of `..` or an absolute path.
+pub(crate) fn local_relative_path(path: &Path) -> PathBuf {
+    let mut rel_path = PathBuf::new();
+    for component in path.components() {
+        match component {
+            Component::Prefix(_) | Component::RootDir | Component::CurDir => {}
+            Component::ParentDir => drop(rel_path.pop()), // noop if empty
+            Component::Normal(name) => rel_path.push(name),
+        }
     }
-    let _ = try_symlink_header(prj, path, original);
+    rel_path
 }
 
-fn try_symlink_header(prj: &Project, path: &Path, original: &Path) -> Result<()> {
-    let mut dst = include_dir(prj);
-    dst.extend(package_name());
-    dst.push(original);
-
-    let parent = dst.parent().unwrap();
-    fs::create_dir_all(parent)?;
-    let _ = fs::remove_file(&dst);
-    symlink_or_copy(path, &dst)?;
-
-    let mut file_name = dst.file_name().unwrap().to_os_string();
-    file_name.push(".h");
-    let ref dst2 = dst.with_file_name(file_name);
-    symlink_or_copy(path, dst2)?;
+pub(crate) fn namespaced(base: &Path, rel_path: &Path) -> PathBuf {
+    let mut path = base.to_owned();
+    path.push("cxxbridge");
+    path.extend(package_name());
+    path.push(rel_path);
+    path
+}
 
-    Ok(())
+pub(crate) fn symlink_namespaced(src: &Path, base: &Path, rel_path: &Path) {
+    let _ = symlink_or_copy(src, namespaced(base, rel_path));
 }
 
-pub(crate) fn out_with_extension(prj: &Project, rel_path: &Path, ext: &str) -> PathBuf {
-    let mut file_name = rel_path.file_name().unwrap().to_owned();
-    file_name.push(ext);
+pub(crate) trait PathExt {
+    fn with_appended_extension(&self, suffix: impl AsRef<OsStr>) -> PathBuf;
+}
 
-    let mut res = prj.out_dir.clone();
-    res.push("cxxbridge");
-    res.extend(package_name());
-    res.push(rel_path);
-    res.with_file_name(file_name)
+impl PathExt for Path {
+    fn with_appended_extension(&self, suffix: impl AsRef<OsStr>) -> PathBuf {
+        let mut file_name = self.file_name().unwrap().to_owned();
+        file_name.push(suffix);
+        self.with_file_name(file_name)
+    }
 }
 
 pub(crate) fn include_dir(prj: &Project) -> PathBuf {

